// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_nav_msgs:msg/Command.idl
// generated code does not contain a copyright notice
#include "marti_nav_msgs/msg/detail/command__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `startstop`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
marti_nav_msgs__msg__Command__init(marti_nav_msgs__msg__Command * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_nav_msgs__msg__Command__fini(msg);
    return false;
  }
  // startstop
  if (!rosidl_runtime_c__int32__Sequence__init(&msg->startstop, 0)) {
    marti_nav_msgs__msg__Command__fini(msg);
    return false;
  }
  return true;
}

void
marti_nav_msgs__msg__Command__fini(marti_nav_msgs__msg__Command * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // startstop
  rosidl_runtime_c__int32__Sequence__fini(&msg->startstop);
}

marti_nav_msgs__msg__Command *
marti_nav_msgs__msg__Command__create()
{
  marti_nav_msgs__msg__Command * msg = (marti_nav_msgs__msg__Command *)malloc(sizeof(marti_nav_msgs__msg__Command));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__msg__Command));
  bool success = marti_nav_msgs__msg__Command__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__msg__Command__destroy(marti_nav_msgs__msg__Command * msg)
{
  if (msg) {
    marti_nav_msgs__msg__Command__fini(msg);
  }
  free(msg);
}


bool
marti_nav_msgs__msg__Command__Sequence__init(marti_nav_msgs__msg__Command__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_nav_msgs__msg__Command * data = NULL;
  if (size) {
    data = (marti_nav_msgs__msg__Command *)calloc(size, sizeof(marti_nav_msgs__msg__Command));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__msg__Command__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__msg__Command__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__msg__Command__Sequence__fini(marti_nav_msgs__msg__Command__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__msg__Command__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__msg__Command__Sequence *
marti_nav_msgs__msg__Command__Sequence__create(size_t size)
{
  marti_nav_msgs__msg__Command__Sequence * array = (marti_nav_msgs__msg__Command__Sequence *)malloc(sizeof(marti_nav_msgs__msg__Command__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__msg__Command__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__msg__Command__Sequence__destroy(marti_nav_msgs__msg__Command__Sequence * array)
{
  if (array) {
    marti_nav_msgs__msg__Command__Sequence__fini(array);
  }
  free(array);
}
