// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_nav_msgs:msg/PathPlanning.idl
// generated code does not contain a copyright notice
#include "marti_nav_msgs/msg/detail/path_planning__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
marti_nav_msgs__msg__PathPlanning__init(marti_nav_msgs__msg__PathPlanning * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_nav_msgs__msg__PathPlanning__fini(msg);
    return false;
  }
  // segment_type
  // length
  // start_speed
  // end_speed
  // startx
  // starty
  // endx
  // endy
  // theta0
  // a1
  // a2
  // k0
  // c1
  // c2
  // behavior
  // creep
  // acc
  // reverse
  // vehicle_track
  // transmitted
  // aux_transmitted
  // theta_end
  // k_end
  // seg_len
  // speed_limit
  // max_error
  // max_smooth
  // max_curv
  // possible_points
  // exit_segment
  return true;
}

void
marti_nav_msgs__msg__PathPlanning__fini(marti_nav_msgs__msg__PathPlanning * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // segment_type
  // length
  // start_speed
  // end_speed
  // startx
  // starty
  // endx
  // endy
  // theta0
  // a1
  // a2
  // k0
  // c1
  // c2
  // behavior
  // creep
  // acc
  // reverse
  // vehicle_track
  // transmitted
  // aux_transmitted
  // theta_end
  // k_end
  // seg_len
  // speed_limit
  // max_error
  // max_smooth
  // max_curv
  // possible_points
  // exit_segment
}

marti_nav_msgs__msg__PathPlanning *
marti_nav_msgs__msg__PathPlanning__create()
{
  marti_nav_msgs__msg__PathPlanning * msg = (marti_nav_msgs__msg__PathPlanning *)malloc(sizeof(marti_nav_msgs__msg__PathPlanning));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_nav_msgs__msg__PathPlanning));
  bool success = marti_nav_msgs__msg__PathPlanning__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_nav_msgs__msg__PathPlanning__destroy(marti_nav_msgs__msg__PathPlanning * msg)
{
  if (msg) {
    marti_nav_msgs__msg__PathPlanning__fini(msg);
  }
  free(msg);
}


bool
marti_nav_msgs__msg__PathPlanning__Sequence__init(marti_nav_msgs__msg__PathPlanning__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_nav_msgs__msg__PathPlanning * data = NULL;
  if (size) {
    data = (marti_nav_msgs__msg__PathPlanning *)calloc(size, sizeof(marti_nav_msgs__msg__PathPlanning));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_nav_msgs__msg__PathPlanning__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_nav_msgs__msg__PathPlanning__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_nav_msgs__msg__PathPlanning__Sequence__fini(marti_nav_msgs__msg__PathPlanning__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_nav_msgs__msg__PathPlanning__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_nav_msgs__msg__PathPlanning__Sequence *
marti_nav_msgs__msg__PathPlanning__Sequence__create(size_t size)
{
  marti_nav_msgs__msg__PathPlanning__Sequence * array = (marti_nav_msgs__msg__PathPlanning__Sequence *)malloc(sizeof(marti_nav_msgs__msg__PathPlanning__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_nav_msgs__msg__PathPlanning__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_nav_msgs__msg__PathPlanning__Sequence__destroy(marti_nav_msgs__msg__PathPlanning__Sequence * array)
{
  if (array) {
    marti_nav_msgs__msg__PathPlanning__Sequence__fini(array);
  }
  free(array);
}
