// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marti_nav_msgs:msg/PathPlanning.idl
// generated code does not contain a copyright notice

#ifndef MARTI_NAV_MSGS__MSG__DETAIL__PATH_PLANNING__STRUCT_H_
#define MARTI_NAV_MSGS__MSG__DETAIL__PATH_PLANNING__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

// Struct defined in msg/PathPlanning in the package marti_nav_msgs.
typedef struct marti_nav_msgs__msg__PathPlanning
{
  std_msgs__msg__Header header;
  int32_t segment_type;
  float length;
  float start_speed;
  float end_speed;
  float startx;
  float starty;
  float endx;
  float endy;
  float theta0;
  float a1;
  float a2;
  float k0;
  float c1;
  float c2;
  int32_t behavior;
  int32_t creep;
  int32_t acc;
  int32_t reverse;
  int32_t vehicle_track;
  bool transmitted;
  bool aux_transmitted;
  float theta_end;
  float k_end;
  int32_t seg_len;
  float speed_limit;
  float max_error;
  float max_smooth;
  float max_curv;
  int32_t possible_points;
  bool exit_segment;
} marti_nav_msgs__msg__PathPlanning;

// Struct for a sequence of marti_nav_msgs__msg__PathPlanning.
typedef struct marti_nav_msgs__msg__PathPlanning__Sequence
{
  marti_nav_msgs__msg__PathPlanning * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} marti_nav_msgs__msg__PathPlanning__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MARTI_NAV_MSGS__MSG__DETAIL__PATH_PLANNING__STRUCT_H_
