// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from marti_nav_msgs:msg/TrackedObject.idl
// generated code does not contain a copyright notice

#ifndef MARTI_NAV_MSGS__MSG__DETAIL__TRACKED_OBJECT__STRUCT_H_
#define MARTI_NAV_MSGS__MSG__DETAIL__TRACKED_OBJECT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'VEHICLE'.
enum
{
  marti_nav_msgs__msg__TrackedObject__VEHICLE = 0
};

/// Constant 'PEDESTRIAN'.
enum
{
  marti_nav_msgs__msg__TrackedObject__PEDESTRIAN = 1
};

/// Constant 'UNKNOWN'.
enum
{
  marti_nav_msgs__msg__TrackedObject__UNKNOWN = 255
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_with_covariance__struct.h"
// Member 'velocity'
#include "geometry_msgs/msg/detail/twist_with_covariance__struct.h"
// Member 'linear_acceleration'
#include "geometry_msgs/msg/detail/vector3__struct.h"
// Member 'polygon'
#include "geometry_msgs/msg/detail/point__struct.h"
// Member 'age_duration'
// Member 'prediction_duration'
#include "builtin_interfaces/msg/detail/duration__struct.h"

// Struct defined in msg/TrackedObject in the package marti_nav_msgs.
typedef struct marti_nav_msgs__msg__TrackedObject
{
  std_msgs__msg__Header header;
  uint16_t id;
  geometry_msgs__msg__PoseWithCovariance pose;
  geometry_msgs__msg__TwistWithCovariance velocity;
  geometry_msgs__msg__Vector3 linear_acceleration;
  double linear_acceleration_covariance[9];
  geometry_msgs__msg__Point__Sequence polygon;
  float length;
  float length_quality;
  float width;
  float width_quality;
  uint8_t classification;
  float classification_quality;
  float existence_probability;
  builtin_interfaces__msg__Duration age_duration;
  builtin_interfaces__msg__Duration prediction_duration;
  bool active;
} marti_nav_msgs__msg__TrackedObject;

// Struct for a sequence of marti_nav_msgs__msg__TrackedObject.
typedef struct marti_nav_msgs__msg__TrackedObject__Sequence
{
  marti_nav_msgs__msg__TrackedObject * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} marti_nav_msgs__msg__TrackedObject__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // MARTI_NAV_MSGS__MSG__DETAIL__TRACKED_OBJECT__STRUCT_H_
