// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from marti_nav_msgs:srv/PlanRoute.idl
// generated code does not contain a copyright notice

#ifndef MARTI_NAV_MSGS__SRV__DETAIL__PLAN_ROUTE__FUNCTIONS_H_
#define MARTI_NAV_MSGS__SRV__DETAIL__PLAN_ROUTE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "marti_nav_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "marti_nav_msgs/srv/detail/plan_route__struct.h"

/// Initialize srv/PlanRoute message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * marti_nav_msgs__srv__PlanRoute_Request
 * )) before or use
 * marti_nav_msgs__srv__PlanRoute_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
bool
marti_nav_msgs__srv__PlanRoute_Request__init(marti_nav_msgs__srv__PlanRoute_Request * msg);

/// Finalize srv/PlanRoute message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__srv__PlanRoute_Request__fini(marti_nav_msgs__srv__PlanRoute_Request * msg);

/// Create srv/PlanRoute message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * marti_nav_msgs__srv__PlanRoute_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
marti_nav_msgs__srv__PlanRoute_Request *
marti_nav_msgs__srv__PlanRoute_Request__create();

/// Destroy srv/PlanRoute message.
/**
 * It calls
 * marti_nav_msgs__srv__PlanRoute_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__srv__PlanRoute_Request__destroy(marti_nav_msgs__srv__PlanRoute_Request * msg);


/// Initialize array of srv/PlanRoute messages.
/**
 * It allocates the memory for the number of elements and calls
 * marti_nav_msgs__srv__PlanRoute_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
bool
marti_nav_msgs__srv__PlanRoute_Request__Sequence__init(marti_nav_msgs__srv__PlanRoute_Request__Sequence * array, size_t size);

/// Finalize array of srv/PlanRoute messages.
/**
 * It calls
 * marti_nav_msgs__srv__PlanRoute_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__srv__PlanRoute_Request__Sequence__fini(marti_nav_msgs__srv__PlanRoute_Request__Sequence * array);

/// Create array of srv/PlanRoute messages.
/**
 * It allocates the memory for the array and calls
 * marti_nav_msgs__srv__PlanRoute_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
marti_nav_msgs__srv__PlanRoute_Request__Sequence *
marti_nav_msgs__srv__PlanRoute_Request__Sequence__create(size_t size);

/// Destroy array of srv/PlanRoute messages.
/**
 * It calls
 * marti_nav_msgs__srv__PlanRoute_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__srv__PlanRoute_Request__Sequence__destroy(marti_nav_msgs__srv__PlanRoute_Request__Sequence * array);

/// Initialize srv/PlanRoute message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * marti_nav_msgs__srv__PlanRoute_Response
 * )) before or use
 * marti_nav_msgs__srv__PlanRoute_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
bool
marti_nav_msgs__srv__PlanRoute_Response__init(marti_nav_msgs__srv__PlanRoute_Response * msg);

/// Finalize srv/PlanRoute message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__srv__PlanRoute_Response__fini(marti_nav_msgs__srv__PlanRoute_Response * msg);

/// Create srv/PlanRoute message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * marti_nav_msgs__srv__PlanRoute_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
marti_nav_msgs__srv__PlanRoute_Response *
marti_nav_msgs__srv__PlanRoute_Response__create();

/// Destroy srv/PlanRoute message.
/**
 * It calls
 * marti_nav_msgs__srv__PlanRoute_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__srv__PlanRoute_Response__destroy(marti_nav_msgs__srv__PlanRoute_Response * msg);


/// Initialize array of srv/PlanRoute messages.
/**
 * It allocates the memory for the number of elements and calls
 * marti_nav_msgs__srv__PlanRoute_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
bool
marti_nav_msgs__srv__PlanRoute_Response__Sequence__init(marti_nav_msgs__srv__PlanRoute_Response__Sequence * array, size_t size);

/// Finalize array of srv/PlanRoute messages.
/**
 * It calls
 * marti_nav_msgs__srv__PlanRoute_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__srv__PlanRoute_Response__Sequence__fini(marti_nav_msgs__srv__PlanRoute_Response__Sequence * array);

/// Create array of srv/PlanRoute messages.
/**
 * It allocates the memory for the array and calls
 * marti_nav_msgs__srv__PlanRoute_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
marti_nav_msgs__srv__PlanRoute_Response__Sequence *
marti_nav_msgs__srv__PlanRoute_Response__Sequence__create(size_t size);

/// Destroy array of srv/PlanRoute messages.
/**
 * It calls
 * marti_nav_msgs__srv__PlanRoute_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_marti_nav_msgs
void
marti_nav_msgs__srv__PlanRoute_Response__Sequence__destroy(marti_nav_msgs__srv__PlanRoute_Response__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // MARTI_NAV_MSGS__SRV__DETAIL__PLAN_ROUTE__FUNCTIONS_H_
